Bug 24682 - zh_CN first weekday should be Monday per GB/T 7408-2005
Summary: zh_CN first weekday should be Monday per GB/T 7408-2005
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: localedata (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: 2.31
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2019-06-14 17:07 UTC by Alick Zhao
Modified: 2019-08-29 02:25 UTC (History)
4 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments
GB/T 7408-2005 Section 3.28 (19.65 KB, image/png)
2019-06-14 17:07 UTC, Alick Zhao
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Alick Zhao 2019-06-14 17:07:32 UTC
Created attachment 11838 [details]
GB/T 7408-2005 Section 3.28

The first day of the week in China (Mainland) should be Monday according to the national standard GB/T 7408-2005 [1]. It is also true in terms of common perception, speaking as someone who was born there and has lived there 20+ years.

I think we need something like "first_weekday 2" to https://sourceware.org/git/?p=glibc.git;a=blob;f=localedata/locales/zh_CN;h=62a46415c1567ed38d58140312cef11eed46092c;hb=HEAD

The issue was found in glibc 2.28 on Fedora 29 affecting the display of "GNOME Calendar" [2] and is also present at git master HEAD. I believe it is better for this to be fixed upstream.

[1] https://www.doc88.com/p-1166696540287.html p.7 Section 3.28 (In Chinese, saying "A calendar week starts with Monday".)
[2] https://lists.fedoraproject.org/archives/list/chinese@lists.fedoraproject.org/thread/2HPTSSSFYWXDO75HOS2OTCYKNYA4DX2O/
Comment 1 Rafal Luzynski 2019-06-17 23:56:14 UTC
Thank you for the report.  Unfortunately, I can't read Chinese.  Also unfortunately CLDR which is our most authoritative source still says it should be Sunday. [1] Can you please file a new ticket in CLDR so we get some feedback from them? [2] [3]


[1] https://github.com/unicode-org/cldr/blob/master/common/supplemental/supplementalData.xml#L4703
[2] http://unicode.org/cldr/trac/newticket
[3] http://cldr.unicode.org/index/bug-reports
Comment 2 Alick Zhao 2019-06-18 05:18:00 UTC
Thanks for the pointers. I found the same issue was raised there at CLDR: https://unicode-org.atlassian.net/browse/CLDR-11510 . I've mentioned the information I have there just now.
Comment 3 Rafal Luzynski 2019-06-21 21:55:13 UTC
Good, let's see what's their feedback. If they don't answer anything by the end of this development cycle then I think I will accept your proposed changes but for now let's give them some time.
Comment 4 cvs-commit@gcc.gnu.org 2019-08-22 22:09:25 UTC
The master branch has been updated by Rafal Luzynski <rl@sourceware.org>:

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=c0fd3244e71db39cef1e2d1d8ba12bb8b7375ce4

commit c0fd3244e71db39cef1e2d1d8ba12bb8b7375ce4
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Thu Aug 22 23:50:04 2019 +0200

    Chinese locales: Set first_weekday to 2 (bug 24682).
    
    The first day of the week in China (Mainland) should be Monday according
    to the national standard GB/T 7408-2005.  References:
    
    * https://www.doc88.com/p-1166696540287.html
    * https://unicode-org.atlassian.net/browse/CLDR-11510
    
    	[BZ #24682]
    	* localedata/locales/bo_CN (first_weekday): Add, set to 2 (Monday).
    	* localedata/locales/ug_CN (first_weekday): Likewise.
    	* localedata/locales/zh_CN (first_weekday): Likewise.
Comment 5 Rafal Luzynski 2019-08-22 22:16:03 UTC
I am sorry, I was going to fix this just before the 2.30 release but I forgot.  It is fixed now in master for the future 2.31 release.  I will try to backport, though.

The same as in bug 24200 comment 2 I decided to introduce the same change to all *_CN locales because CLDR assigns the first weekday to whole territory (all languages if there are multiple).
Comment 6 cvs-commit@gcc.gnu.org 2019-08-28 20:45:03 UTC
The release/2.30/master branch has been updated by Rafal Luzynski <rl@sourceware.org>:

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=d74461fa348de4176894f98672cb9ce721e26676

commit d74461fa348de4176894f98672cb9ce721e26676
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Thu Aug 22 23:50:04 2019 +0200

    Chinese locales: Set first_weekday to 2 (bug 24682).
    
    The first day of the week in China (Mainland) should be Monday according
    to the national standard GB/T 7408-2005.  References:
    
    * https://www.doc88.com/p-1166696540287.html
    * https://unicode-org.atlassian.net/browse/CLDR-11510
    
    	[BZ #24682]
    	* NEWS: Mention this bug fixed.
    	* localedata/locales/bo_CN (first_weekday): Add, set to 2 (Monday).
    	* localedata/locales/ug_CN (first_weekday): Likewise.
    	* localedata/locales/zh_CN (first_weekday): Likewise.
    
    (cherry picked from commit c0fd3244e71db39cef1e2d1d8ba12bb8b7375ce4)
Comment 7 Wei-Lun Chao 2019-08-29 02:25:52 UTC
The first day of the week in Taiwan should be also Monday according to the national standard CNS 7648 [1].

Some patches have been merged into bug 24409

[1] https://www.cnsonline.com.tw/?node=result&generalno=7648 p.10 Section 3.2.2